# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from locomotor_msgs/NavigationState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import nav_2d_msgs.msg
import std_msgs.msg

class NavigationState(genpy.Message):
  _md5sum = "3518ca42eb49bbf8de6cf123dcd80e4a"
  _type = "locomotor_msgs/NavigationState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """nav_2d_msgs/Pose2DStamped global_pose
nav_2d_msgs/Pose2DStamped local_pose
nav_2d_msgs/Pose2DStamped goal
nav_2d_msgs/Twist2DStamped current_velocity
nav_2d_msgs/Twist2DStamped command_velocity
nav_2d_msgs/Path2D global_plan

================================================================================
MSG: nav_2d_msgs/Pose2DStamped
Header header
geometry_msgs/Pose2D pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose2D
# Deprecated
# Please use the full 3D pose.

# In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.

# If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.


# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta

================================================================================
MSG: nav_2d_msgs/Twist2DStamped
std_msgs/Header header
Twist2D velocity

================================================================================
MSG: nav_2d_msgs/Twist2D
float64 x
float64 y
float64 theta

================================================================================
MSG: nav_2d_msgs/Path2D
Header header
geometry_msgs/Pose2D[] poses
"""
  __slots__ = ['global_pose','local_pose','goal','current_velocity','command_velocity','global_plan']
  _slot_types = ['nav_2d_msgs/Pose2DStamped','nav_2d_msgs/Pose2DStamped','nav_2d_msgs/Pose2DStamped','nav_2d_msgs/Twist2DStamped','nav_2d_msgs/Twist2DStamped','nav_2d_msgs/Path2D']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       global_pose,local_pose,goal,current_velocity,command_velocity,global_plan

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NavigationState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.global_pose is None:
        self.global_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.local_pose is None:
        self.local_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.goal is None:
        self.goal = nav_2d_msgs.msg.Pose2DStamped()
      if self.current_velocity is None:
        self.current_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.command_velocity is None:
        self.command_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.global_plan is None:
        self.global_plan = nav_2d_msgs.msg.Path2D()
    else:
      self.global_pose = nav_2d_msgs.msg.Pose2DStamped()
      self.local_pose = nav_2d_msgs.msg.Pose2DStamped()
      self.goal = nav_2d_msgs.msg.Pose2DStamped()
      self.current_velocity = nav_2d_msgs.msg.Twist2DStamped()
      self.command_velocity = nav_2d_msgs.msg.Twist2DStamped()
      self.global_plan = nav_2d_msgs.msg.Path2D()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.global_pose.header.seq, _x.global_pose.header.stamp.secs, _x.global_pose.header.stamp.nsecs))
      _x = self.global_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.global_pose.pose.x, _x.global_pose.pose.y, _x.global_pose.pose.theta, _x.local_pose.header.seq, _x.local_pose.header.stamp.secs, _x.local_pose.header.stamp.nsecs))
      _x = self.local_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.local_pose.pose.x, _x.local_pose.pose.y, _x.local_pose.pose.theta, _x.goal.header.seq, _x.goal.header.stamp.secs, _x.goal.header.stamp.nsecs))
      _x = self.goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.current_velocity.header.seq, _x.current_velocity.header.stamp.secs, _x.current_velocity.header.stamp.nsecs))
      _x = self.current_velocity.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.current_velocity.velocity.x, _x.current_velocity.velocity.y, _x.current_velocity.velocity.theta, _x.command_velocity.header.seq, _x.command_velocity.header.stamp.secs, _x.command_velocity.header.stamp.nsecs))
      _x = self.command_velocity.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.command_velocity.velocity.x, _x.command_velocity.velocity.y, _x.command_velocity.velocity.theta, _x.global_plan.header.seq, _x.global_plan.header.stamp.secs, _x.global_plan.header.stamp.nsecs))
      _x = self.global_plan.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.global_plan.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.global_plan.poses:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.theta))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.global_pose is None:
        self.global_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.local_pose is None:
        self.local_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.goal is None:
        self.goal = nav_2d_msgs.msg.Pose2DStamped()
      if self.current_velocity is None:
        self.current_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.command_velocity is None:
        self.command_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.global_plan is None:
        self.global_plan = nav_2d_msgs.msg.Path2D()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.global_pose.header.seq, _x.global_pose.header.stamp.secs, _x.global_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.global_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.global_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.global_pose.pose.x, _x.global_pose.pose.y, _x.global_pose.pose.theta, _x.local_pose.header.seq, _x.local_pose.header.stamp.secs, _x.local_pose.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.local_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.local_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.local_pose.pose.x, _x.local_pose.pose.y, _x.local_pose.pose.theta, _x.goal.header.seq, _x.goal.header.stamp.secs, _x.goal.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.current_velocity.header.seq, _x.current_velocity.header.stamp.secs, _x.current_velocity.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.current_velocity.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.current_velocity.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.current_velocity.velocity.x, _x.current_velocity.velocity.y, _x.current_velocity.velocity.theta, _x.command_velocity.header.seq, _x.command_velocity.header.stamp.secs, _x.command_velocity.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command_velocity.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.command_velocity.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.command_velocity.velocity.x, _x.command_velocity.velocity.y, _x.command_velocity.velocity.theta, _x.global_plan.header.seq, _x.global_plan.header.stamp.secs, _x.global_plan.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.global_plan.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.global_plan.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.global_plan.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose2D()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _get_struct_3d().unpack(str[start:end])
        self.global_plan.poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.global_pose.header.seq, _x.global_pose.header.stamp.secs, _x.global_pose.header.stamp.nsecs))
      _x = self.global_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.global_pose.pose.x, _x.global_pose.pose.y, _x.global_pose.pose.theta, _x.local_pose.header.seq, _x.local_pose.header.stamp.secs, _x.local_pose.header.stamp.nsecs))
      _x = self.local_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.local_pose.pose.x, _x.local_pose.pose.y, _x.local_pose.pose.theta, _x.goal.header.seq, _x.goal.header.stamp.secs, _x.goal.header.stamp.nsecs))
      _x = self.goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.current_velocity.header.seq, _x.current_velocity.header.stamp.secs, _x.current_velocity.header.stamp.nsecs))
      _x = self.current_velocity.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.current_velocity.velocity.x, _x.current_velocity.velocity.y, _x.current_velocity.velocity.theta, _x.command_velocity.header.seq, _x.command_velocity.header.stamp.secs, _x.command_velocity.header.stamp.nsecs))
      _x = self.command_velocity.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_3d3I().pack(_x.command_velocity.velocity.x, _x.command_velocity.velocity.y, _x.command_velocity.velocity.theta, _x.global_plan.header.seq, _x.global_plan.header.stamp.secs, _x.global_plan.header.stamp.nsecs))
      _x = self.global_plan.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.global_plan.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.global_plan.poses:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.theta))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.global_pose is None:
        self.global_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.local_pose is None:
        self.local_pose = nav_2d_msgs.msg.Pose2DStamped()
      if self.goal is None:
        self.goal = nav_2d_msgs.msg.Pose2DStamped()
      if self.current_velocity is None:
        self.current_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.command_velocity is None:
        self.command_velocity = nav_2d_msgs.msg.Twist2DStamped()
      if self.global_plan is None:
        self.global_plan = nav_2d_msgs.msg.Path2D()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.global_pose.header.seq, _x.global_pose.header.stamp.secs, _x.global_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.global_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.global_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.global_pose.pose.x, _x.global_pose.pose.y, _x.global_pose.pose.theta, _x.local_pose.header.seq, _x.local_pose.header.stamp.secs, _x.local_pose.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.local_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.local_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.local_pose.pose.x, _x.local_pose.pose.y, _x.local_pose.pose.theta, _x.goal.header.seq, _x.goal.header.stamp.secs, _x.goal.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.current_velocity.header.seq, _x.current_velocity.header.stamp.secs, _x.current_velocity.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.current_velocity.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.current_velocity.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.current_velocity.velocity.x, _x.current_velocity.velocity.y, _x.current_velocity.velocity.theta, _x.command_velocity.header.seq, _x.command_velocity.header.stamp.secs, _x.command_velocity.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command_velocity.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.command_velocity.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.command_velocity.velocity.x, _x.command_velocity.velocity.y, _x.command_velocity.velocity.theta, _x.global_plan.header.seq, _x.global_plan.header.stamp.secs, _x.global_plan.header.stamp.nsecs,) = _get_struct_3d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.global_plan.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.global_plan.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.global_plan.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose2D()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _get_struct_3d().unpack(str[start:end])
        self.global_plan.poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_3d3I = None
def _get_struct_3d3I():
    global _struct_3d3I
    if _struct_3d3I is None:
        _struct_3d3I = struct.Struct("<3d3I")
    return _struct_3d3I
